_G.ShowXPinChat = _G.ShowXPinChat or {}
ShowXPinChat._path = ModPath
ShowXPinChat._data_path = SavePath .. "ShowXPinChat_Config.json"
ShowXPinChat._data = {}

function ShowXPinChat:Save()
	local file = io.open(self._data_path, "w")
	if file then
		file:write(json.encode(self._data))
		file:close()
	end
end

function ShowXPinChat:Load()
	local file = io.open(self._data_path, "r")
	
	if file then
		self._data = json.decode(file:read("*all"))
		file:close()
		
		if ShowXPinChat._data.ShowXPinChat_messagetype == nil then
			ShowXPinChat._data.ShowXPinChat_messagetype = 2
			ShowXPinChat:Save()
		end
		if ShowXPinChat._data.ShowXPinChat_prefix == nil then
			ShowXPinChat._data.ShowXPinChat_prefix = "XPChat"
			ShowXPinChat:Save()
		end
		if ShowXPinChat._data.ShowXPinChat_color == nil then
			ShowXPinChat._data.ShowXPinChat_color = "24b4fa"
			ShowXPinChat:Save()
		end
		if ShowXPinChat._data.ShowXPinChat_xptype == nil then
			ShowXPinChat._data.ShowXPinChat_xptype = 1
			ShowXPinChat:Save()
		end
		if ShowXPinChat._data.ShowXPinChat_ignore == nil then
			ShowXPinChat._data.ShowXPinChat_ignore = 0
			ShowXPinChat:Save()
		end
	end
	if not file then
		ShowXPinChat._data.ShowXPinChat_messagetype = 2
		ShowXPinChat._data.ShowXPinChat_prefix = "XPChat"
		ShowXPinChat._data.ShowXPinChat_color = "24b4fa"
		ShowXPinChat._data.ShowXPinChat_xptype = 1
		ShowXPinChat._data.ShowXPinChat_ignore = 0
		ShowXPinChat:Save()
	end
end

Hooks:AddHook("LocalizationManagerPostInit" , "LocalizationManagerPostInit_ShowXPinChat", function(loc)
	loc:load_localization_file(ShowXPinChat._path .. "loc/en.txt")
end)

Hooks:AddHook("MenuManagerInitialize", "MenuManagerInitialize_ShowXPinChat", function(menu_manager)
	
	MenuCallbackHandler.ShowXPinChat_messagetype_callback = function(self, item)
		ShowXPinChat._data.ShowXPinChat_messagetype = item:value()
		ShowXPinChat:Save()
	end
	
	MenuCallbackHandler.ShowXPinChat_prefix_callback = function(self, item)
		ShowXPinChat._data.ShowXPinChat_prefix = item:value()
		ShowXPinChat:Save()
	end
	
	MenuCallbackHandler.ShowXPinChat_color_callback = function(self, item)
		ShowXPinChat._data.ShowXPinChat_color = item:value()
		ShowXPinChat:Save()
	end
	
	MenuCallbackHandler.ShowXPinChat_xptype_callback = function(self, item)
		ShowXPinChat._data.ShowXPinChat_xptype  = item:value()
		ShowXPinChat:Save()
	end
	
	MenuCallbackHandler.ShowXPinChat_ignore_callback = function(self, item)
		ShowXPinChat._data.ShowXPinChat_ignore = item:value()
		ShowXPinChat:Save()
	end
	
	ShowXPinChat:Load()
	MenuHelper:LoadFromJsonFile(ShowXPinChat._path .. "menu/options.json", ShowXPinChat, ShowXPinChat._data)
end)

function ShowXPinChat:ShowXPinChat_messagetype()
	return ShowXPinChat._data.ShowXPinChat_messagetype
end

function ShowXPinChat:ShowXPinChat_prefix()
	return ShowXPinChat._data.ShowXPinChat_prefix
end

function ShowXPinChat:ShowXPinChat_color()
	return ShowXPinChat._data.ShowXPinChat_color
end

function ShowXPinChat:ShowXPinChat_xptype()
	return ShowXPinChat._data.ShowXPinChat_xptype
end

function ShowXPinChat:ShowXPinChat_ignore()
	return ShowXPinChat._data.ShowXPinChat_ignore
end

function ShowXPinChat:send_message(msg, types)
	if types == 1 then
		managers.chat:send_message(1,'?',msg)
	end
	
	if types == 2 then
		if Network:is_server() then
			managers.chat:send_message(1,'?',msg)
		else
			managers.chat:_receive_message(1, ShowXPinChat._data.ShowXPinChat_prefix, msg, Color(ShowXPinChat._data.ShowXPinChat_color))
		end
	end
	
	if types == 3 then
		if Network:is_server() then
			managers.chat:send_message(1,'?',msg)
		else
			return
		end
	end
	
	if types == 4 then
		managers.chat:_receive_message(1, ShowXPinChat._data.ShowXPinChat_prefix, msg, Color(ShowXPinChat._data.ShowXPinChat_color))
	end
	
	if types == 5 then
		return
	end
end